#!/usr/bin/env python

"""The setup script."""

from setuptools import setup, find_packages

with open("README.rst") as readme_file:
    readme = readme_file.read()

with open("HISTORY.rst") as history_file:
    history = history_file.read()

requirements = ["spsdk>=2.0"]

test_requirements = ["pytest>=3"]

setup(
    author="First Last",
    author_email="me@example.com",
    python_requires=">=3.8",
    classifiers=[
        "Development Status :: 2 - Pre-Alpha",
        "Intended Audience :: Developers",
        "License :: OSI Approved :: MIT License",
        "Natural Language :: English",
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.8",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: Python :: 3.11",
    ],
    description="My WPC Service plugin for SPSDK.",
    install_requires=requirements,
    license="MIT",
    long_description=readme + "\n\n" + history,
    include_package_data=True,
    keywords="my_wpc_service_plugin",
    name="my_wpc_service_plugin",
    packages=find_packages(
        include=["my_wpc_service_plugin", "my_wpc_service_plugin.*"],
    ),
    test_suite="tests",
    tests_require=test_requirements,
    url="https://github.com/me/my_wpc_service_plugin",
    version="0.1.0",
    zip_safe=False,
    entry_points={
        "spsdk.wpc.service": [
            "mywpc = my_wpc_service_plugin.my_wpc_service_plugin",
        ]
    },
)
