#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
# Copyright 2024 NXP
#
# SPDX-License-Identifier: BSD-3-Clause

"""Test for fuses handling."""
from spsdk import version as spsdk_version
from spsdk.utils.database import DatabaseManager
from spsdk.utils.fuses import FuseScript


def test_fuse_script():
    """Test FuseScript class."""
    fuse_script = FuseScript("mx93", "a0", DatabaseManager.AHAB)
    assert fuse_script.family == "mx93"
    assert fuse_script.revision == "a0"
    assert fuse_script.tool == "nxpele"
    assert fuse_script.name == "AHAB SRK"
    assert fuse_script.get_fuse_write_cmd(0, 0) == "write-fuse --index 0 --data 0"
    assert (
        fuse_script.generate_file_header() == f"# nxpele AHAB SRK fuses programming script\n"
        f"# Generated by SPSDK {spsdk_version}\n"
        f"# Family: mx93 Revision: a0"
    )
